---
title: TextRange
slug: Web/API/TextRange
tags:
  - API
  - DHTML
  - DOM
  - TextRange
---
<div>{{ ApiRef("DOM") }}{{Non-standard_Header}}</div>

<div class="notecard warning">
<p><strong>IE Only</strong></p>
This property is IE specific. Although it is well supported by IE, most other browsers no longer support this property. This property should only be used as one of the solutions when you need to be compatible with lower versions of IE, rather than relying on it completely in cross browser scripts.</div>

<p>A <code>TextRange</code> object represents a fragment of text in a document, similar to the standard defined {{domxref("Range")}} interface.</p>

<p>This object is used to represent a specific piece of text in the document. For example, when you hold down the mouse to select the content on the page, you create a typical <code>TextRange</code>. It is implemented in IE, then a <code>TextRange</code> object can be created by {{domxref("Element.createTextRange()")}} or {{domxref("Document.selection.createRange()")}}.</p>

<p>Note that this interface is not supported in non IE browsers. Alternative {{domxref("Selection")}} and {{domxref("Range")}} interfaces can be used.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("TextRange.boundingHeight")}}{{ReadOnlyInline}}</dt>
 <dd>
 <p>Returns the height of the rectangle bound to the <code>TextRange</code> object.</p>
 </dd>
 <dt>{{domxref("TextRange.boundingLeft")}}{{ReadOnlyInline}}</dt>
 <dd>Returns the distance between the left edge of the rectangle that binds the <code>TextRange</code> object and the left edge that completely contains the <code>TextRange</code> object.</dd>
 <dt>{{domxref("TextRange.boundingTop")}}{{ReadOnlyInline}}</dt>
 <dd>Returns the distance between the top edge of the rectangle that binds the <code>TextRange</code> object and the top edge that completely contains the <code>TextRange</code> object.</dd>
 <dt>{{domxref("TextRange.boundingWidth")}}{{ReadOnlyInline}}</dt>
 <dd>
 <p>Returns the width of the rectangle bound to the <code>TextRange</code> object.</p>
 </dd>
 <dt>{{domxref("TextRange.htmlText")}}</dt>
 <dd>Gets or sets the HTML content within the <code>TextRange</code>.</dd>
 <dt>{{domxref("TextRange.text")}}</dt>
 <dd>Gets or sets the plaintext content within the <code>TextRange</code>.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("TextRange.collapse()")}}</dt>
 <dd>Move the caret to the beginning or end of the current range.</dd>
 <dt>{{domxref("TextRange.duplicate()")}}</dt>
 <dd>
 <p>Returns a copy of <code style="font-size: 1rem; letter-spacing: -0.00278rem;">TextRange</code><span style="font-size: 1rem; letter-spacing: -0.00278rem;">.</span></p>
 </dd>
 <dt>{{domxref("TextRange.execCommand()")}}</dt>
 <dd>Executes a <a href="/zh-CN/docs/Web/API/Document/execCommand">command</a> on the current document, the current selection, or the given scope.</dd>
 <dt>{{domxref("TextRange.expand()")}}</dt>
 <dd>Expand the range to include the full range of specified units. For example, expanding a <code>"word"</code> means that the words at both ends of the range will completely included in the range. <code>xpand to wor</code> may become <code>expand to words</code>, etc.</dd>
 <dt>{{domxref("TextRange.findText()")}}</dt>
 <dd>Searches the specified text in the original range and adjusts the range to include the first match.</dd>
 <dt>{{domxref("TextRange.inRange()")}}</dt>
 <dd>Returns whether the current range contains the specified range.</dd>
 <dt>{{domxref("TextRange.isEqual()")}}</dt>
 <dd>Returns whether the current range is equal to the specified range.</dd>
 <dt>{{domxref("TextRange.move()")}}</dt>
 <dd>Collapses the range and moves the blank range by a specified number of units. Such as, <code>move("character",-1)</code> means to move one character to the left.</dd>
 <dt>{{domxref("TextRange.moveEnd()")}}</dt>
 <dd>Moves the end of the range by a specified number of units.</dd>
 <dt>{{domxref("TextRange.moveStart()")}}</dt>
 <dd>Moves the start of the range by a specified number of units.</dd>
 <dt>{{domxref("TextRange.moveToElementText()")}}</dt>
 <dd>Causes the range to contain the text of the specified element. Can only be used on {{domxref("Element")}} objects.</dd>
 <dt>{{domxref("TextRange.parentElement()")}}</dt>
 <dd>Returns the parent element of the range, which is the smallest element that contains the range completely. If the selection contains more than one element, when you modify the contents of the selection, the contents will be placed in the corresponding position of the parent element instead of the child element.</dd>
 <dt>{{domxref("TextRange.pasteHTML()")}}</dt>
 <dd>Paste the HTML content into the given range and replace any previous text and HTML elements in the range.</dd>
 <dt>{{domxref("TextRange.queryCommandEnabled()")}}</dt>
 <dd>Returns a {{jsxref("Boolean")}} indicating whether the specified command can be executed successfully with the <code>execCommand</code> method in the current state of the given document. You can also see {{domxref("Document.queryCommandEnabled()")}}.</dd>
 <dt>{{domxref("TextRange.queryCommandState()")}}</dt>
 <dd>Returns the {{jsxref("Boolean")}} indicating the current state of the specified command. You can also see {{domxref("Document.queryCommandState()")}}.</dd>
 <dt>{{domxref("TextRange.queryCommandValue()")}}</dt>
 <dd>Returns the {{domxref("DOMString")}} indicating the current value of the specified command. You can also see {{domxref("Document.queryCommandValue()")}}.</dd>
 <dt>{{domxref("TextRange.scrollIntoView()")}}</dt>
 <dd>Scroll the range to the visible range (top or bottom). It can be used as an alternative to {{domxref("Element.scrollIntoView")}} in the lower version of IE.</dd>
 <dt>{{domxref("TextRange.select()")}}</dt>
 <dd>Select the current range (i.e. the blue selection seen by the user).</dd>
 <dt>{{domxref("TextRange.setEndPoint()")}}</dt>
 <dd>Sets the end point of the current range based on the bounds of other <code>TextRange</code>.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following example is valid under IE9. The example gets the <code>TextRange</code> through <code>document.selection</code>, and sets the specified element to be selected. IE9 supports the standard alternative {{domxref("Range")}}.</p>

<pre class="brush:js">var range = document.selection.createRange();
var element = document.getElementById("test");
range.moveToElementText(element);
range.select();
// Selected "SomeTextToBeSelected"</pre>

<pre class="brush:html"><code>&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;head&gt;
  &lt;title&gt;TextRange Example&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
  &lt;p id="test"&gt;</code>SomeTextToBeSelected<code>&lt;/p&gt;
&lt;/body&gt;
&lt;/html&gt;</code></pre>

<h2 id="Notes">Notes</h2>

<h3 id="Use_TextRange_to_Operate_the_Selection">Use TextRange to Operate the Selection</h3>

<div class="notecard warning">
<p>Valid only under <strong>IE9</strong>. The {{domxref("selection")}} interface should be used first, if the browser allows it.</p>
</div>

<p>{{domxref("document.selection")}} property returns a non-standard <code>selection</code> object, and the <code>selection.createRange()</code> method creates a <code>TextRange</code> object consistent with the currently selection.</p>

<pre class="brush:js">var sel = document.selection;
var range = sel.createRange();
alert(range.text);
// Output plaintext of the selection</pre>

<p>Note that the <code>createRange</code> method does not create a reference. If you want to select the modified range after modifying the selection, you need to call the <code>TextRange.select</code> method.</p>

<h3 id="selection_Compatibility"><code>selection</code> Compatibility</h3>

<p>The <code>document.selection</code> object is the primary purpose of <code>TextRange</code>. This object is used to process the selected ranges in the document, and is mainly implemented by using the <code>TextRange</code> interface. According to the standard, a window / document may have multiple non adjacent selection, but only Firefox can select multiple ranges through <kbd>Ctrl</kbd>; generally, only one selected <code>TextRange</code> is allowed in ie. </p>

<p>However, in other browsers, <code>document</code> does not have a so-called <code>selection</code> attribute - they operate on the selection through the standard <a href="/en-US/docs/Web/API/Selection_API">Selection API</a>, that is, they get the <code>Selection</code> object through the <code>window.getselection()</code> method, and use the standard <code>Range</code> object to process the text fragment. IE9 and later also gave up the <code>document.selection</code> object and switched to the standard interface (although <code>TextRange</code> has been reserved, it has lost its function in most cases).</p>

<p>It's easy to get confused. Generally, if the script only needs to be compatible with the latest browser, the standard interface is the best choice; however, the current website still wants to be compatible with IE8 or below browsers. Therefore, the best way is to deal with both at the same time, that is, try to use <code>TextRange</code> mode when the standard interface is not supported, but do not regard it as the only choice.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="row" style="width: 15px;"></th>
   <th scope="col">IE</th>
   <th scope="col">Other Browsers</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <th scope="row" style="width: 15%;">{{domxref("TextRange")}}{{non-standard_inline()}}</th>
   <td>≤8(Standard API after IE9)</td>
   <td style="width: 60%;">No Support (See <a href="/en-US/docs/Web/API/Selection_API">Selection API</a>)</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Selection")}} and {{domxref("Range")}} standard interface</li>
 <li><a href="/en-US/docs/Web/API/Selection_API">Selection API</a> to replace this non-standard interface</li>
</ul>
